



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[Python 多线程] Barrier (十一)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[Python 多线程] Barrier (十一)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 15:20:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Barrier</p>
<p>栅栏，也叫屏障。可以想象成路障、道闸。</p>
<p>Python 3.2引入的新功能。</p>
<p>构造方法：</p>
<p>threading.Barrier(parties, action=None, timeout=None)</p>
<p>构建Barrier对象，parties 指定参与方数目，timeout是wait方法未指定时超时的默认值。</p>
<p>n_waiting&nbsp; &nbsp; 当前在栅栏中等待的线程数</p>
<p>parties&nbsp; &nbsp; &nbsp; &nbsp; 通过栅栏所需的线程数</p>
<p>wait(timeout=None) 等待通过栅栏，返回0到线程数-1的整数(barrier_id)，每个线程返回不同。如果wait方法设置了超时，并超时发送，栅栏将处于broken状态。</p>
<p>例1：</p>
<div>
<pre class="prettyprint linenums">#Barrier 栅栏<br />
import threading,logging<br />
logging.basicConfig(level=logging.INFO,format="[-] %(threadName)s %(message)s")

def work(barrier:threading.Barrier):<br />
    logging.info("n_waiting = {}".format(barrier.n_waiting))   # 等待的线程数<br />
    bid = barrier.wait()   # 参与者的id，返回0到线程数减1的数值<br />
    logging.info("after barrier {}".format(bid))  # 栅栏之后

barrier = threading.Barrier(3) # 3个参与者，每3个开闸放行，0,1,2  4,5,6

for x in range(1,4):  # 所有参数者个数，4,5,6,10,15<br />
    threading.Event().wait(1)<br />
    threading.Thread(target=work,args=(barrier,),name="Barrier-{}".format(x)).start()

运行结果：<br />
[-] Barrier-1 n_waiting = 0<br />
[-] Barrier-2 n_waiting = 1<br />
[-] Barrier-3 n_waiting = 2<br />
[-] Barrier-3 after barrier 2<br />
[-] Barrier-2 after barrier 1<br />
[-] Barrier-1 after barrier 0
</pre>
</div>
<p>　　每一个进来就等待，不够3个就阻塞，直到够3个就开闸放行。</p>
<p>Barrier实例的方法：</p>
<p>broken&nbsp; 检测栅栏是否处于打破的状态，返回True或False</p>
<p>abort()&nbsp; 将栅栏置于broken状态，等待中的线程或者调用等待方法的线程都会抛出threading.BrokenBarrieError异常，直到reset方法来恢复栅栏</p>
<p>reset()&nbsp; 恢复栅栏，重新开始拦截</p>
<p>例2：</p>
<div>
<pre class="prettyprint linenums">#Barrier 栅栏<br />
import threading,logging<br />
logging.basicConfig(level=logging.INFO,format="[-] %(threadName)s %(message)s")

def work(barrier:threading.Barrier):<br />
    logging.info("n_waiting = {}".format(barrier.n_waiting))<br />
    try:<br />
        bid = barrier.wait()<br />
        logging.info("after barrier {}".format(bid))<br />
    except threading.BrokenBarrierError:<br />
        logging.info("Broken Barrier in {}".format(threading.current_thread()))

barrier = threading.Barrier(3)

for x in range(1,12): #12个<br />
    if x == 3:<br />
        barrier.abort() #有一个人坏了规矩<br />
    elif x == 6:<br />
        barrier.reset()<br />
    threading.Event().wait(1)<br />
    threading.Thread(target=work,args=(barrier,),name="Barrier-{}".format(x)).start()

运行结果：<br />
[-] Barrier-1 n_waiting = 0 #0,1<br />
[-] Barrier-2 n_waiting = 1<br />
[-] Barrier-2 Broken Barrier in &lt;Thread(Barrier-2, started 3124)&gt;<br />
[-] Barrier-1 Broken Barrier in &lt;Thread(Barrier-1, started 8036)&gt;<br />
[-] Barrier-3 n_waiting = 0<br />
[-] Barrier-3 Broken Barrier in &lt;Thread(Barrier-3, started 7428)&gt;<br />
[-] Barrier-4 n_waiting = 0<br />
[-] Barrier-4 Broken Barrier in &lt;Thread(Barrier-4, started 1828)&gt;<br />
[-] Barrier-5 n_waiting = 0<br />
[-] Barrier-5 Broken Barrier in &lt;Thread(Barrier-5, started 7416)&gt;<br />
[-] Barrier-6 n_waiting = 0 #6,7,8<br />
[-] Barrier-7 n_waiting = 1<br />
[-] Barrier-8 n_waiting = 2<br />
[-] Barrier-8 after barrier 2<br />
[-] Barrier-7 after barrier 1<br />
[-] Barrier-6 after barrier 0<br />
[-] Barrier-9 n_waiting = 0  #9,10,11<br />
[-] Barrier-10 n_waiting = 1<br />
[-] Barrier-11 n_waiting = 2<br />
[-] Barrier-11 after barrier 2<br />
[-] Barrier-9 after barrier 0<br />
[-] Barrier-10 after barrier 1
</pre>
</div>
<p>　　一共有12个参与者，依次开始，1和2处于等待状态，到达第3的时候，进入了broken状态，则直到第6个，才恢复栅栏，从6开始继续拦截，达到3个(6,7,8)就放行，9,10,11也放行。</p>
<p>例3：</p>
<p>wait方法</p>
<div>
<pre class="prettyprint linenums">#Barrier 栅栏<br />
import threading,logging<br />
logging.basicConfig(level=logging.INFO,format="[-] %(threadName)s %(message)s")

def work(barrier:threading.Barrier,i:int):<br />
    logging.info("n_waiting = {}".format(barrier.n_waiting))<br />
    try:<br />
        if i &lt; 3:<br />
            bid = barrier.wait(1)  #超时1秒就将栅栏置于broken状态，抛出异常后续语句不会执行<br />
        else:<br />
            if i == 6:<br />
                barrier.reset() #恢复栅栏<br />
            bid = barrier.wait()<br />
        # logging.info("broken status = {}".format(barrier.broken))  #是否处于broken状态<br />
        logging.info("after barrier {}".format(bid))<br />
    except threading.BrokenBarrierError:<br />
        logging.info("Broken Barrier in {}".format(threading.current_thread()))

barrier = threading.Barrier(3)

for i in range(1,11): #10个<br />
    threading.Event().wait(2) #强制延迟2秒,让出时间片<br />
    threading.Thread(target=work,args=(barrier,i),name="Barrier-{}".format(i)).start()

运行结果：<br />
[-] Barrier-1 n_waiting = 0<br />
[-] Barrier-1 Broken Barrier in &lt;Thread(Barrier-1, started 3100)&gt;<br />
[-] Barrier-2 n_waiting = 0<br />
[-] Barrier-2 Broken Barrier in &lt;Thread(Barrier-2, started 8836)&gt;<br />
[-] Barrier-3 n_waiting = 0<br />
[-] Barrier-3 Broken Barrier in &lt;Thread(Barrier-3, started 8428)&gt;<br />
[-] Barrier-4 n_waiting = 0<br />
[-] Barrier-4 Broken Barrier in &lt;Thread(Barrier-4, started 1204)&gt;<br />
[-] Barrier-5 n_waiting = 0<br />
[-] Barrier-5 Broken Barrier in &lt;Thread(Barrier-5, started 1556)&gt;<br />
[-] Barrier-6 n_waiting = 0<br />
[-] Barrier-7 n_waiting = 1<br />
[-] Barrier-8 n_waiting = 2<br />
[-] Barrier-8 after barrier 2<br />
[-] Barrier-7 after barrier 1<br />
[-] Barrier-6 after barrier 0<br />
[-] Barrier-9 n_waiting = 0<br />
[-] Barrier-10 n_waiting = 1<br />
阻塞中
</pre>
</div>
<p>　　wait方法在等待超时1秒后，就强制将栅栏置于broken状态，直到第6个的时候才reset恢复，然后6,7,8放行，9,10,继续阻塞。如果此时有第11个，就会9,10,11放行。</p>
<p>应用场景：</p>
<p>并发初始化</p>
<p>所有线程都必须初始化完成后，才能继续工作，例如运行前加载数据，检查，如果这些工作没完成就不能正常工作运行。</p>
<p>10个线程做10种工作准备，每个线程负责一种工作，只有10个线程都完成后，才能继续工作，先完成的要等待后完成的线程。</p>
<p>例如，启动一个程序，需要先加载磁盘文件、缓存预热、初始化连接池等工作，这些工作可以齐头并进，不过只有都满足了，程序才能继续向后执行。假设数据库链接失败，则初始化工作失败，就要abort，栅栏broken，所有线程收到异常退出。</p>
<p>工作量</p>
<p>有10个计算任务，完成6个，就算工作完成。</p>
<p>PPTBYG</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnd5428.html">mysql连接超时与jndi数据源配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r77e78.html">优秀的JavaScript开发框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrek0q.html">Redis安装和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8keex38.html">斯坦福第六课：逻辑回归&lpar;Logistic Regression&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10mo39.html">sql 中各种锁随记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnk0vz8.html">java生态环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p000n8.html">Samza&sol;KafkaAnalysizing</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnd5r8.html">C&num;&lowbar;单例模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1v002q.html">利用requestjs优化响应式移动端js加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z4mze9.html">纯代码系列：Python实现验证码图片&lpar;PIL库经典用法用法，爬虫12306思路&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603z3y9.html">The host &apos;192&period;168&period;174&period;130&apos; is unreachable&period; the host may be down&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvog7r8.html">Linux 日志分析脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyeorjq.html">JavaSE Collection集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkgnvn8.html">A - 摆仙果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj5k5vq.html">liunx trac 安装记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/963ykej9.html">java程序运行时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4yg1lq.html">DevOps Workshop 研发运维一体化（北京第二场） 2016&period;04&period;27</a>
		</li>
						<li><a href="https://www.batexi.com/a/8korv77q.html">cocos creator踩坑日记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlwzpvq.html">4196&colon; &lbrack;Noi2015&rsqb;软件包管理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44p4neq.html">android 下使用Direct Texture</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1rzd19.html">bnu 4060 奇偶性，异或运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvel56j9.html">redux实现原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkw1l38.html">BZOJ3625&colon; 小朋友和二叉树</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnno1zjq.html">BZOJ3529&colon; &lbrack;Sdoi2014&rsqb;数表&lpar;莫比乌斯反演 树状数组&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p0p1eq.html">Python爬虫教程-04-response简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko7mj6q.html">【眼见为实】自己动手实践理解数据库READ COMMITTED &amp;amp&semi;&amp;amp&semi; MVCC</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpwgnz9.html">December 05th 2016 Week 50th Monday</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm3vz09.html">Microsoft Visual Studio 遇到了问题需要关闭</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnogjjq.html">GO语言 切片的缩短和增长原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvk6omq.html">如何去掉android的标题栏</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
